USE AdventureWorks2008R2;
GO
-- Schema fr Beispiele anlegen
CREATE SCHEMA Bsp;
GO


-- Beispiel 2
-- Eindeutige IDs ber mehrere Tabellen


-- Eine Sequence erstellen
CREATE SEQUENCE Bsp.FortlaufendeNummer As int
	START WITH 1
	INCREMENT BY 1;
GO

-- Beispieltabelle 1 anlegen
CREATE TABLE Bsp.Vorgaenge
(
	ID int PRIMARY KEY CLUSTERED 
			DEFAULT (NEXT VALUE FOR Bsp.FortlaufendeNummer),
	Zeitpunkt datetime NOT NULL DEFAULT (getdate()),
	Vorgang nvarchar(50) NULL,
	Status nvarchar(5) NOT NULL
);
GO

-- Beispieltabelle 2 anlegen
CREATE TABLE Bsp.Schritte
(
	ID int PRIMARY KEY CLUSTERED 
			DEFAULT (NEXT VALUE FOR Bsp.FortlaufendeNummer),
	Zeitpunkt datetime NOT NULL DEFAULT (getdate()),
	Vorgang nvarchar(50) NOT NULL,
	Meldung nvarchar(300) NULL
);
GO

-- Beispieltabelle 3 anlegen
CREATE TABLE Bsp.Fehler
(
	ID int PRIMARY KEY CLUSTERED 
			DEFAULT (NEXT VALUE FOR Bsp.FortlaufendeNummer),
	Zeitpunkt datetime NOT NULL DEFAULT (getdate()),
	Vorgang nvarchar(50) NULL,
	Meldung nvarchar(300) NULL
);
GO


-- Beispieldaten einfgen
INSERT	Bsp.Vorgaenge  (Vorgang, Status) 
		VALUES ('Drucken', 'Start');
INSERT	Bsp.Schritte (Vorgang, Meldung) 
		VALUES ('Drucken', 'Daten an Drucker senden');
INSERT	Bsp.Schritte (Vorgang, Meldung) 
		VALUES ('Drucken', 'Papier einziehen');
INSERT	Bsp.Fehler (Vorgang, Meldung) 
		VALUES ('Drucken', 'Papierfach leer');
INSERT	Bsp.Vorgaenge  (Vorgang, Status) 
		VALUES ('Drucken', 'Ende');


-- Ergebnis ausgeben
SELECT	ID, Zeitpunkt, Vorgang, Status As Meldung FROM Bsp.Vorgaenge 
		UNION ALL
SELECT	ID, Zeitpunkt, Vorgang, Meldung FROM Bsp.Schritte 
		UNION ALL 
SELECT	ID, Zeitpunkt, Vorgang, Meldung FROM Bsp.Fehler
ORDER BY ID


-- Aufrumen
DROP TABLE Bsp.Vorgaenge 
DROP TABLE Bsp.Schritte
DROP TABLE Bsp.Fehler
DROP SEQUENCE Bsp.FortlaufendeNummer
DROP SCHEMA Bsp