USE AdventureWorks2008R2;

-- Schema fr Beispiele anlegen
CREATE SCHEMA Bsp;
GO




-- Beispiel 1 
-- Wiederverwendung eines Wertebereichs

CREATE SEQUENCE Bsp.WiederkehrendeNummern AS tinyint
	START WITH 1
	INCREMENT BY 1
	MINVALUE 1
	MAXVALUE 5
	CYCLE;

SELECT	NEXT VALUE FOR Bsp.WiederkehrendeNummern As Gruppe, 
		LastName, FirstName
FROM	Person.Person;




-- Beispiel 2
-- Zeilennummer in Ergebnismenge

CREATE SEQUENCE Bsp.Zeilennummer AS int
	START WITH 1
	INCREMENT BY 1
GO

SELECT	NEXT VALUE FOR Bsp.Zeilennummer OVER (ORDER BY LastName) As Zeilennummer,
		LastName, FirstName
FROM	Person.Person


-- Aufrumen
DROP SEQUENCE Bsp.WiederkehrendeNummern
DROP SEQUENCE Bsp.Zeilennummer
DROP SCHEMA Bsp
