USE AdventureWorks2008R2;
GO
CREATE SCHEMA Bsp;
GO

SELECT	BusinessEntityID, LastName, FirstName
FROM	Person.Person 
ORDER BY BusinessEntityID;


-- Beispiel 1
-- Positionierung - ab dem 11. Datensatz
SELECT	BusinessEntityID, LastName, FirstName
FROM	Person.Person 
ORDER BY BusinessEntityID
		 OFFSET 10 ROWS;


-- Beispiel 2
-- Teilmenge - 5 Datenstze ab dem 11. Datensatz
SELECT	BusinessEntityID, LastName, FirstName
FROM	Person.Person 
ORDER BY BusinessEntityID
		 OFFSET 10 ROWS FETCH NEXT 5 ROWS ONLY;


-- Beispiel 3
-- Teilmenge - mit Parametern 
DECLARE @Beginn int = 19000,
		@Ende int = 10;

SELECT	BusinessEntityID, LastName, FirstName
FROM	Person.Person 
ORDER BY BusinessEntityID
		 OFFSET @Beginn ROWS FETCH NEXT @Ende ROWS ONLY;


-- Beispiel 4
-- Teilmenge - noch flexibler


-- Beispieltabelle anlegen
CREATE TABLE Bsp.Optionen
(
	Leitung nvarchar(5) NOT NULL,
	AnzahlZeilen int NOT NULL
);
-- Daten hinzufgen
INSERT Bsp.Optionen VALUES('DSL', 20), ('ISDN', 5);


DECLARE @Start tinyint = 3;

SELECT	BusinessEntityID, LastName, FirstName
FROM	Person.Person 
ORDER BY BusinessEntityID
		 OFFSET @Start ROWS 
		 FETCH NEXT 
		 (SELECT AnzahlZeilen 
		  FROM Bsp.Optionen 
		  WHERE Leitung = 'DSL') ROWS ONLY;


-- Aufrumen
DROP TABLE Bsp.Optionen 
DROP SCHEMA Bsp